# coding: utf-8

"""
    Notehub API

    The OpenAPI definition for the Notehub.io API. 

    The version of the OpenAPI document: 1.0.0
    Contact: engineering@blues.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from notehub_py.models.http_filter import HttpFilter
from typing import Optional, Set
from typing_extensions import Self

class Twilio(BaseModel):
    """
    Route settings specific to Twilio routes.  Only used for Twilio route types
    """ # noqa: E501
    fleets: Optional[Annotated[List[StrictStr], Field(min_length=0)]] = Field(default=None, description="list of Fleet UIDs to apply route to, if any.  If empty, applies to all Fleets")
    filter: Optional[HttpFilter] = None
    timeout: Optional[StrictInt] = Field(default=15, description="Timeout in seconds for each request")
    account_sid: Optional[StrictStr] = Field(default=None, description="Twilio Account SID")
    auth_token: Optional[StrictStr] = Field(default=None, description="Twilio Auth Token.  This value will be omitted from the response and replaced with a placeholder.")
    to: Optional[StrictStr] = Field(default=None, description="Phone number to send SMS to, leave blank to use notefile, must use E.164 format")
    var_from: Optional[StrictStr] = Field(default=None, description="Phone number to send SMS from, leave blank to use notefile, must use E.164 format", alias="from")
    message: Optional[StrictStr] = Field(default=None, description="Message to send, leave blank to use notefile.")
    throttle_ms: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["fleets", "filter", "timeout", "account_sid", "auth_token", "to", "from", "message", "throttle_ms"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Twilio from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of filter
        if self.filter:
            _dict['filter'] = self.filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Twilio from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fleets": obj.get("fleets"),
            "filter": HttpFilter.from_dict(obj["filter"]) if obj.get("filter") is not None else None,
            "timeout": obj.get("timeout") if obj.get("timeout") is not None else 15,
            "account_sid": obj.get("account_sid"),
            "auth_token": obj.get("auth_token"),
            "to": obj.get("to"),
            "from": obj.get("from"),
            "message": obj.get("message"),
            "throttle_ms": obj.get("throttle_ms")
        })
        return _obj


